goog.provide('shadow.cljs.devtools.client.node');
shadow.cljs.devtools.client.node.node_eval = (function shadow$cljs$devtools$client$node$node_eval(p__49635){
var map__49636 = p__49635;
var map__49636__$1 = cljs.core.__destructure_map(map__49636);
var msg = map__49636__$1;
var js = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49636__$1,new cljs.core.Keyword(null,"js","js",1768080579));
var source_map_json = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49636__$1,new cljs.core.Keyword(null,"source-map-json","source-map-json",-299460036));
var result = SHADOW_NODE_EVAL(js,source_map_json);
return result;
});
shadow.cljs.devtools.client.node.is_loaded_QMARK_ = (function shadow$cljs$devtools$client$node$is_loaded_QMARK_(src){
return goog.object.get(SHADOW_IMPORTED,src) === true;
});
shadow.cljs.devtools.client.node.closure_import = (function shadow$cljs$devtools$client$node$closure_import(src){
if(typeof src === 'string'){
} else {
throw (new Error("Assert failed: (string? src)"));
}

return SHADOW_IMPORT(src);
});
shadow.cljs.devtools.client.node.handle_build_complete = (function shadow$cljs$devtools$client$node$handle_build_complete(runtime,p__49638){
var map__49639 = p__49638;
var map__49639__$1 = cljs.core.__destructure_map(map__49639);
var msg = map__49639__$1;
var info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49639__$1,new cljs.core.Keyword(null,"info","info",-317069002));
var reload_info = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49639__$1,new cljs.core.Keyword(null,"reload-info","reload-info",1648088086));
var map__49640 = info;
var map__49640__$1 = cljs.core.__destructure_map(map__49640);
var sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49640__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var compiled = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49640__$1,new cljs.core.Keyword(null,"compiled","compiled",850043082));
var warnings = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49640__$1,new cljs.core.Keyword(null,"warnings","warnings",-735437651));
if(((shadow.cljs.devtools.client.env.autoload) && (((cljs.core.empty_QMARK_(warnings)) || (shadow.cljs.devtools.client.env.ignore_warnings))))){
var files_to_require = cljs.core.into.cljs$core$IFn$_invoke$arity$2(cljs.core.PersistentVector.EMPTY,cljs.core.map.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"output-name","output-name",-1769107767),cljs.core.filter.cljs$core$IFn$_invoke$arity$2((function (p__49641){
var map__49642 = p__49641;
var map__49642__$1 = cljs.core.__destructure_map(map__49642);
var ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49642__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
var resource_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49642__$1,new cljs.core.Keyword(null,"resource-id","resource-id",-1308422582));
return ((cljs.core.contains_QMARK_(compiled,resource_id)) || (cljs.core.contains_QMARK_(new cljs.core.Keyword(null,"always-load","always-load",66405637).cljs$core$IFn$_invoke$arity$1(reload_info),ns)));
}),cljs.core.remove.cljs$core$IFn$_invoke$arity$2((function (p__49643){
var map__49644 = p__49643;
var map__49644__$1 = cljs.core.__destructure_map(map__49644);
var ns = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49644__$1,new cljs.core.Keyword(null,"ns","ns",441598760));
return cljs.core.contains_QMARK_(new cljs.core.Keyword(null,"never-load","never-load",1300896819).cljs$core$IFn$_invoke$arity$1(reload_info),ns);
}),sources))));
if(cljs.core.seq(files_to_require)){
return shadow.cljs.devtools.client.env.do_js_reload.cljs$core$IFn$_invoke$arity$2(msg,(function (){
var seq__49647 = cljs.core.seq(files_to_require);
var chunk__49648 = null;
var count__49649 = (0);
var i__49650 = (0);
while(true){
if((i__49650 < count__49649)){
var src = chunk__49648.cljs$core$IIndexed$_nth$arity$2(null,i__49650);
shadow.cljs.devtools.client.env.before_load_src(src);

shadow.cljs.devtools.client.node.closure_import(src);


var G__49709 = seq__49647;
var G__49710 = chunk__49648;
var G__49711 = count__49649;
var G__49712 = (i__49650 + (1));
seq__49647 = G__49709;
chunk__49648 = G__49710;
count__49649 = G__49711;
i__49650 = G__49712;
continue;
} else {
var temp__5753__auto__ = cljs.core.seq(seq__49647);
if(temp__5753__auto__){
var seq__49647__$1 = temp__5753__auto__;
if(cljs.core.chunked_seq_QMARK_(seq__49647__$1)){
var c__4649__auto__ = cljs.core.chunk_first(seq__49647__$1);
var G__49713 = cljs.core.chunk_rest(seq__49647__$1);
var G__49714 = c__4649__auto__;
var G__49715 = cljs.core.count(c__4649__auto__);
var G__49716 = (0);
seq__49647 = G__49713;
chunk__49648 = G__49714;
count__49649 = G__49715;
i__49650 = G__49716;
continue;
} else {
var src = cljs.core.first(seq__49647__$1);
shadow.cljs.devtools.client.env.before_load_src(src);

shadow.cljs.devtools.client.node.closure_import(src);


var G__49717 = cljs.core.next(seq__49647__$1);
var G__49718 = null;
var G__49719 = (0);
var G__49720 = (0);
seq__49647 = G__49717;
chunk__49648 = G__49718;
count__49649 = G__49719;
i__49650 = G__49720;
continue;
}
} else {
return null;
}
}
break;
}
}));
} else {
return null;
}
} else {
return null;
}
});
shadow.cljs.devtools.client.node.client_info = new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"host","host",-1558485167),new cljs.core.Keyword(null,"node","node",581201198),new cljs.core.Keyword(null,"desc","desc",2093485764),["Node ",cljs.core.str.cljs$core$IFn$_invoke$arity$1(process.version)].join('')], null);
shadow.cljs.devtools.client.node.start = (function shadow$cljs$devtools$client$node$start(runtime){
var ws_url = shadow.cljs.devtools.client.env.get_ws_relay_url();
var socket = (new shadow.js.shim.module$ws(ws_url,({"rejectUnauthorized": false})));
var ws_active_ref = cljs.core.atom.cljs$core$IFn$_invoke$arity$1(true);
socket.on("message",(function (data){
if(cljs.core.truth_(cljs.core.deref(ws_active_ref))){
return shadow.cljs.devtools.client.shared.remote_msg(runtime,data);
} else {
return null;
}
}));

socket.on("open",(function (e){
if(cljs.core.truth_(cljs.core.deref(ws_active_ref))){
return shadow.cljs.devtools.client.shared.remote_open(runtime,e);
} else {
return null;
}
}));

socket.on("close",(function (e){
if(cljs.core.truth_(cljs.core.deref(ws_active_ref))){
return shadow.cljs.devtools.client.shared.remote_close(runtime,e,ws_url);
} else {
return null;
}
}));

socket.on("error",(function (e){
if(cljs.core.truth_(cljs.core.deref(ws_active_ref))){
return shadow.cljs.devtools.client.shared.remote_error(runtime,e);
} else {
return null;
}
}));

return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"socket","socket",59137063),socket,new cljs.core.Keyword(null,"ws-active-ref","ws-active-ref",804496391),ws_active_ref], null);
});
shadow.cljs.devtools.client.node.send = (function shadow$cljs$devtools$client$node$send(p__49653,msg){
var map__49654 = p__49653;
var map__49654__$1 = cljs.core.__destructure_map(map__49654);
var socket = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49654__$1,new cljs.core.Keyword(null,"socket","socket",59137063));
return socket.send(msg);
});
shadow.cljs.devtools.client.node.stop = (function shadow$cljs$devtools$client$node$stop(p__49655){
var map__49656 = p__49655;
var map__49656__$1 = cljs.core.__destructure_map(map__49656);
var socket = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49656__$1,new cljs.core.Keyword(null,"socket","socket",59137063));
var ws_active_ref = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49656__$1,new cljs.core.Keyword(null,"ws-active-ref","ws-active-ref",804496391));
cljs.core.reset_BANG_(ws_active_ref,false);

return socket.close();
});
if((shadow.cljs.devtools.client.env.worker_client_id > (0))){
(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$remote$runtime$api$IEvalJS$ = cljs.core.PROTOCOL_SENTINEL);

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$remote$runtime$api$IEvalJS$_js_eval$arity$2 = (function (this$,code){
var this$__$1 = this;
return SHADOW_NODE_EVAL(code);
}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$ = cljs.core.PROTOCOL_SENTINEL);

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_invoke$arity$2 = (function (this$,msg){
var this$__$1 = this;
return shadow.cljs.devtools.client.node.node_eval(msg);
}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_repl_init$arity$4 = (function (runtime,p__49661,done,error){
var map__49662 = p__49661;
var map__49662__$1 = cljs.core.__destructure_map(map__49662);
var repl_sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49662__$1,new cljs.core.Keyword(null,"repl-sources","repl-sources",723867535));
var runtime__$1 = this;
try{var seq__49664_49721 = cljs.core.seq(repl_sources);
var chunk__49666_49722 = null;
var count__49667_49723 = (0);
var i__49668_49724 = (0);
while(true){
if((i__49668_49724 < count__49667_49723)){
var map__49687_49725 = chunk__49666_49722.cljs$core$IIndexed$_nth$arity$2(null,i__49668_49724);
var map__49687_49726__$1 = cljs.core.__destructure_map(map__49687_49725);
var src_49727 = map__49687_49726__$1;
var output_name_49728 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49687_49726__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if((!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_49728)))){
shadow.cljs.devtools.client.node.closure_import(output_name_49728);


var G__49729 = seq__49664_49721;
var G__49730 = chunk__49666_49722;
var G__49731 = count__49667_49723;
var G__49732 = (i__49668_49724 + (1));
seq__49664_49721 = G__49729;
chunk__49666_49722 = G__49730;
count__49667_49723 = G__49731;
i__49668_49724 = G__49732;
continue;
} else {
var G__49733 = seq__49664_49721;
var G__49734 = chunk__49666_49722;
var G__49735 = count__49667_49723;
var G__49736 = (i__49668_49724 + (1));
seq__49664_49721 = G__49733;
chunk__49666_49722 = G__49734;
count__49667_49723 = G__49735;
i__49668_49724 = G__49736;
continue;
}
} else {
var temp__5753__auto___49737 = cljs.core.seq(seq__49664_49721);
if(temp__5753__auto___49737){
var seq__49664_49738__$1 = temp__5753__auto___49737;
if(cljs.core.chunked_seq_QMARK_(seq__49664_49738__$1)){
var c__4649__auto___49739 = cljs.core.chunk_first(seq__49664_49738__$1);
var G__49740 = cljs.core.chunk_rest(seq__49664_49738__$1);
var G__49741 = c__4649__auto___49739;
var G__49742 = cljs.core.count(c__4649__auto___49739);
var G__49743 = (0);
seq__49664_49721 = G__49740;
chunk__49666_49722 = G__49741;
count__49667_49723 = G__49742;
i__49668_49724 = G__49743;
continue;
} else {
var map__49688_49744 = cljs.core.first(seq__49664_49738__$1);
var map__49688_49745__$1 = cljs.core.__destructure_map(map__49688_49744);
var src_49746 = map__49688_49745__$1;
var output_name_49747 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49688_49745__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if((!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_49747)))){
shadow.cljs.devtools.client.node.closure_import(output_name_49747);


var G__49748 = cljs.core.next(seq__49664_49738__$1);
var G__49749 = null;
var G__49750 = (0);
var G__49751 = (0);
seq__49664_49721 = G__49748;
chunk__49666_49722 = G__49749;
count__49667_49723 = G__49750;
i__49668_49724 = G__49751;
continue;
} else {
var G__49752 = cljs.core.next(seq__49664_49738__$1);
var G__49753 = null;
var G__49754 = (0);
var G__49755 = (0);
seq__49664_49721 = G__49752;
chunk__49666_49722 = G__49753;
count__49667_49723 = G__49754;
i__49668_49724 = G__49755;
continue;
}
}
} else {
}
}
break;
}

return (done.cljs$core$IFn$_invoke$arity$0 ? done.cljs$core$IFn$_invoke$arity$0() : done.call(null));
}catch (e49663){var e = e49663;
return (error.cljs$core$IFn$_invoke$arity$1 ? error.cljs$core$IFn$_invoke$arity$1(e) : error.call(null,e));
}}));

(shadow.cljs.devtools.client.shared.Runtime.prototype.shadow$cljs$devtools$client$shared$IHostSpecific$do_repl_require$arity$4 = (function (this$,p__49689,done,error){
var map__49690 = p__49689;
var map__49690__$1 = cljs.core.__destructure_map(map__49690);
var msg = map__49690__$1;
var sources = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49690__$1,new cljs.core.Keyword(null,"sources","sources",-321166424));
var reload_namespaces = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49690__$1,new cljs.core.Keyword(null,"reload-namespaces","reload-namespaces",250210134));
var this$__$1 = this;
try{var seq__49692_49756 = cljs.core.seq(sources);
var chunk__49693_49757 = null;
var count__49694_49758 = (0);
var i__49695_49759 = (0);
while(true){
if((i__49695_49759 < count__49694_49758)){
var map__49698_49760 = chunk__49693_49757.cljs$core$IIndexed$_nth$arity$2(null,i__49695_49759);
var map__49698_49761__$1 = cljs.core.__destructure_map(map__49698_49760);
var src_49762 = map__49698_49761__$1;
var provides_49763 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49698_49761__$1,new cljs.core.Keyword(null,"provides","provides",-1634397992));
var output_name_49764 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49698_49761__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if(cljs.core.truth_((function (){var or__4223__auto__ = (!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_49764)));
if(or__4223__auto__){
return or__4223__auto__;
} else {
return cljs.core.some(reload_namespaces,provides_49763);
}
})())){
shadow.cljs.devtools.client.node.closure_import(output_name_49764);
} else {
}


var G__49765 = seq__49692_49756;
var G__49766 = chunk__49693_49757;
var G__49767 = count__49694_49758;
var G__49768 = (i__49695_49759 + (1));
seq__49692_49756 = G__49765;
chunk__49693_49757 = G__49766;
count__49694_49758 = G__49767;
i__49695_49759 = G__49768;
continue;
} else {
var temp__5753__auto___49769 = cljs.core.seq(seq__49692_49756);
if(temp__5753__auto___49769){
var seq__49692_49770__$1 = temp__5753__auto___49769;
if(cljs.core.chunked_seq_QMARK_(seq__49692_49770__$1)){
var c__4649__auto___49771 = cljs.core.chunk_first(seq__49692_49770__$1);
var G__49772 = cljs.core.chunk_rest(seq__49692_49770__$1);
var G__49773 = c__4649__auto___49771;
var G__49774 = cljs.core.count(c__4649__auto___49771);
var G__49775 = (0);
seq__49692_49756 = G__49772;
chunk__49693_49757 = G__49773;
count__49694_49758 = G__49774;
i__49695_49759 = G__49775;
continue;
} else {
var map__49701_49776 = cljs.core.first(seq__49692_49770__$1);
var map__49701_49777__$1 = cljs.core.__destructure_map(map__49701_49776);
var src_49778 = map__49701_49777__$1;
var provides_49779 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49701_49777__$1,new cljs.core.Keyword(null,"provides","provides",-1634397992));
var output_name_49780 = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49701_49777__$1,new cljs.core.Keyword(null,"output-name","output-name",-1769107767));
if(cljs.core.truth_((function (){var or__4223__auto__ = (!(shadow.cljs.devtools.client.node.is_loaded_QMARK_(output_name_49780)));
if(or__4223__auto__){
return or__4223__auto__;
} else {
return cljs.core.some(reload_namespaces,provides_49779);
}
})())){
shadow.cljs.devtools.client.node.closure_import(output_name_49780);
} else {
}


var G__49781 = cljs.core.next(seq__49692_49770__$1);
var G__49782 = null;
var G__49783 = (0);
var G__49784 = (0);
seq__49692_49756 = G__49781;
chunk__49693_49757 = G__49782;
count__49694_49758 = G__49783;
i__49695_49759 = G__49784;
continue;
}
} else {
}
}
break;
}

return (done.cljs$core$IFn$_invoke$arity$0 ? done.cljs$core$IFn$_invoke$arity$0() : done.call(null));
}catch (e49691){var e = e49691;
return (error.cljs$core$IFn$_invoke$arity$1 ? error.cljs$core$IFn$_invoke$arity$1(e) : error.call(null,e));
}}));

shadow.cljs.devtools.client.shared.add_plugin_BANG_(new cljs.core.Keyword("shadow.cljs.devtools.client.node","client","shadow.cljs.devtools.client.node/client",1327452098),cljs.core.PersistentHashSet.EMPTY,(function (p__49702){
var map__49703 = p__49702;
var map__49703__$1 = cljs.core.__destructure_map(map__49703);
var env = map__49703__$1;
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49703__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
var svc = new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"runtime","runtime",-1331573996),runtime], null);
shadow.remote.runtime.api.add_extension(runtime,new cljs.core.Keyword("shadow.cljs.devtools.client.node","client","shadow.cljs.devtools.client.node/client",1327452098),new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"on-welcome","on-welcome",1895317125),(function (){
shadow.cljs.devtools.client.env.patch_goog_BANG_();

if(shadow.cljs.devtools.client.env.log){
return console.log(["shadow-cljs - #",cljs.core.str.cljs$core$IFn$_invoke$arity$1(new cljs.core.Keyword(null,"client-id","client-id",-464622140).cljs$core$IFn$_invoke$arity$1(cljs.core.deref(new cljs.core.Keyword(null,"state-ref","state-ref",2127874952).cljs$core$IFn$_invoke$arity$1(runtime))))," ready!"].join(''));
} else {
return null;
}
}),new cljs.core.Keyword(null,"on-disconnect","on-disconnect",-809021814),(function (){
return console.warn("The shadow-cljs Websocket was disconnected.");
}),new cljs.core.Keyword(null,"ops","ops",1237330063),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"access-denied","access-denied",959449406),(function (msg){
return console.error(["Stale Output! Your loaded JS was not produced by the running shadow-cljs instance."," Is the watch for this build running?"].join(''));
}),new cljs.core.Keyword(null,"cljs-build-configure","cljs-build-configure",-2089891268),(function (msg){
return null;
}),new cljs.core.Keyword(null,"cljs-build-start","cljs-build-start",-725781241),(function (msg){
return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-start","build-start",-959649480)));
}),new cljs.core.Keyword(null,"cljs-build-complete","cljs-build-complete",273626153),(function (msg){
var msg__$1 = shadow.cljs.devtools.client.env.add_warnings_to_info(msg);
shadow.cljs.devtools.client.node.handle_build_complete(runtime,msg__$1);

return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg__$1,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-complete","build-complete",-501868472)));
}),new cljs.core.Keyword(null,"cljs-build-failure","cljs-build-failure",1718154990),(function (msg){
return shadow.cljs.devtools.client.env.run_custom_notify_BANG_(cljs.core.assoc.cljs$core$IFn$_invoke$arity$3(msg,new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"build-failure","build-failure",-2107487466)));
}),new cljs.core.Keyword("shadow.cljs.devtools.client.env","worker-notify","shadow.cljs.devtools.client.env/worker-notify",-1456820670),(function (p__49704){
var map__49705 = p__49704;
var map__49705__$1 = cljs.core.__destructure_map(map__49705);
var event_op = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49705__$1,new cljs.core.Keyword(null,"event-op","event-op",200358057));
var client_id = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49705__$1,new cljs.core.Keyword(null,"client-id","client-id",-464622140));
if(((cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"client-disconnect","client-disconnect",640227957),event_op)) && (cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(client_id,shadow.cljs.devtools.client.env.worker_client_id)))){
return console.warn("shadow-cljs - The watch for this build was stopped!");
} else {
if(cljs.core._EQ_.cljs$core$IFn$_invoke$arity$2(new cljs.core.Keyword(null,"client-connect","client-connect",-1113973888),event_op)){
return console.warn("shadow-cljs - A new watch for this build was started, restart of this process required!");
} else {
return null;

}
}
})], null)], null));

return svc;
}),(function (p__49706){
var map__49707 = p__49706;
var map__49707__$1 = cljs.core.__destructure_map(map__49707);
var svc = map__49707__$1;
var runtime = cljs.core.get.cljs$core$IFn$_invoke$arity$2(map__49707__$1,new cljs.core.Keyword(null,"runtime","runtime",-1331573996));
return shadow.remote.runtime.api.del_extension(runtime,new cljs.core.Keyword("shadow.cljs.devtools.client.node","client","shadow.cljs.devtools.client.node/client",1327452098));
}));

shadow.cljs.devtools.client.shared.init_runtime_BANG_(shadow.cljs.devtools.client.node.client_info,shadow.cljs.devtools.client.node.start,shadow.cljs.devtools.client.node.send,shadow.cljs.devtools.client.node.stop);
} else {
}

//# sourceMappingURL=shadow.cljs.devtools.client.node.js.map
